// Define a name for the test module.
#define BOOST_TEST_MODULE testRead
// Only after defining the name include the unit test header.
#include <boost/test/included/unit_test.hpp>

#include <ChimeraTK/ApplicationCore/TestFacility.h>
#include "Server.h"
#include "TecDummy.h"


using namespace boost::unit_test_framework;
using namespace ChimeraTK;

BOOST_AUTO_TEST_SUITE(tecTestSuite)

constexpr char TECDummyCDD[] = "(TecDummy:?map=dummydevice.map)";

BOOST_AUTO_TEST_CASE(testReadOnlyInteger){
  std::cout << "testReadOnlyInteger" << std::endl;
  
  Server tec_app{"tec_dummy"};
  ChimeraTK::TestFacility testFacility;
  
  testFacility.runApplication();

  boost::shared_ptr<TecDummy> TECDummy = boost::dynamic_pointer_cast<TecDummy>(
     ChimeraTK::BackendFactory::getInstance().createBackend(TECDummyCDD));
  
  testFacility.writeScalar<int>("TecModule/mon_serialNumber_enaPeriodicRead",1);
  tec_app.periodicRead.sendTrigger();
  testFacility.stepApplication();
  int serialNumber = testFacility.getScalar<int>("TecModule/mon_serialNumber_rd");
  //std::cout<<"serialNumber:"<<serialNumber<<std::endl;
  BOOST_CHECK_EQUAL(serialNumber,0);
    
  TECDummy->set( TecFrame::TecParameter::MonSerialNumber, 999 ); 
  tec_app.periodicRead.sendTrigger();
  testFacility.stepApplication();
  serialNumber = testFacility.getScalar<int>("TecModule/mon_serialNumber_rd");
  //std::cout<<"serialNumber:"<<serialNumber<<std::endl;
  BOOST_CHECK_EQUAL(serialNumber,999);  
}

BOOST_AUTO_TEST_SUITE_END()
